def batch_norm(input: Tensor,
    running_mean: Optional[Tensor],
    running_var: Optional[Tensor],
    weight: Optional[Tensor]=None,
    bias: Optional[Tensor]=None,
    training: bool=False,
    momentum: float=0.10000000000000001,
    eps: float=1.0000000000000001e-05) -> Tensor:
  _0 = __torch__.torch.nn.functional._verify_batch_size
  if training:
    _1 = _0(torch.size(input), )
  else:
    pass
  _2 = torch.batch_norm(input, weight, bias, running_mean, running_var, training, momentum, eps, True)
  return _2
def instance_norm(input: Tensor,
    running_mean: Optional[Tensor]=None,
    running_var: Optional[Tensor]=None,
    weight: Optional[Tensor]=None,
    bias: Optional[Tensor]=None,
    use_input_stats: bool=True,
    momentum: float=0.10000000000000001,
    eps: float=1.0000000000000001e-05) -> Tensor:
  _3 = __torch__.torch.nn.functional._verify_spatial_size
  if use_input_stats:
    _4 = _3(torch.size(input), )
  else:
    pass
  _5 = torch.instance_norm(input, weight, bias, running_mean, running_var, use_input_stats, momentum, eps, True)
  return _5
def group_norm(input: Tensor,
    num_groups: int,
    weight: Optional[Tensor]=None,
    bias: Optional[Tensor]=None,
    eps: float=1.0000000000000001e-05) -> Tensor:
  _6 = __torch__.torch.nn.functional._verify_batch_size
  _7 = torch.mul(torch.size(input, 0), torch.size(input, 1))
  _8 = [torch.floordiv(_7, num_groups), num_groups]
  _9 = torch.list(torch.slice(torch.size(input), 2))
  _10 = _6(torch.add(_8, _9), )
  _11 = torch.group_norm(input, num_groups, weight, bias, eps)
  return _11
def layer_norm(input: Tensor,
    normalized_shape: List[int],
    weight: Optional[Tensor]=None,
    bias: Optional[Tensor]=None,
    eps: float=1.0000000000000001e-05) -> Tensor:
  _12 = torch.layer_norm(input, normalized_shape, weight, bias, eps)
  return _12
def local_response_norm(input: Tensor,
    size: int,
    alpha: float=0.0001,
    beta: float=0.75,
    k: float=1.) -> Tensor:
  _13 = "Expected 3D or higher dimensionality                          input (got {} dimensions)"
  dim = torch.dim(input)
  if torch.lt(dim, 3):
    ops.prim.RaiseException(torch.format(_13, dim))
  else:
    pass
  if torch.eq(torch.numel(input), 0):
    _14 = input
  else:
    div = torch.unsqueeze(torch.mul(input, input), 1)
    if torch.eq(dim, 3):
      _15 = torch.floordiv(size, 2)
      _16 = torch.floordiv(torch.sub(size, 1), 2)
      div1 = __torch__.torch.nn.functional._pad(div, [0, 0, _15, _16], "constant", 0., )
      _17 = torch.avg_pool2d(div1, [size, 1], [1, 1])
      div0 = torch.squeeze(_17, 1)
    else:
      sizes = torch.size(input)
      _18 = [sizes[0], 1, sizes[1], sizes[2], -1]
      div2 = torch.view(div, _18)
      _19 = torch.floordiv(size, 2)
      _20 = torch.floordiv(torch.sub(size, 1), 2)
      div3 = __torch__.torch.nn.functional._pad(div2, [0, 0, 0, 0, _19, _20], "constant", 0., )
      _21 = torch.avg_pool3d(div3, [size, 1, 1], [1, 1, 1])
      div4 = torch.squeeze(_21, 1)
      div0 = torch.view(div4, sizes)
    _22 = torch.add(torch.mul(div0, alpha), k)
    div5 = torch.pow(_22, beta)
    _14 = torch.div(input, div5)
  return _14
def _verify_batch_size(size: List[int]) -> NoneType:
  _23 = "Expected more than 1 value per channel when training, got input size {}"
  size_prods = size[0]
  size_prods0 = size_prods
  for i in range(torch.sub(torch.len(size), 2)):
    size_prods1 = torch.mul(size_prods0, size[torch.add(i, 2)])
    size_prods0 = size_prods1
  if torch.eq(size_prods0, 1):
    ops.prim.RaiseException(torch.format(_23, size))
  else:
    pass
  return None
def _verify_spatial_size(size: List[int]) -> NoneType:
  _24 = "Expected more than 1 spatial element when training, got input size {}"
  _25 = torch.__range_length(2, torch.len(size), 1)
  size_prods = 1
  for _26 in range(_25):
    i = torch.__derive_index(_26, 2, 1)
    size_prods = torch.mul(size_prods, size[i])
  if torch.eq(size_prods, 1):
    ops.prim.RaiseException(torch.format(_24, size))
  else:
    pass
  return None
def _pad(input: Tensor,
    pad: List[int],
    mode: str="constant",
    value: float=0.) -> Tensor:
  _27 = "AssertionError: Padding length must be divisible by 2"
  _28 = "AssertionError: Padding length too large"
  _29 = "Padding mode \"{}\"\" doesn\'t take in value argument"
  _30 = __torch__.torch.nn.functional._pad_circular
  _31 = "Only 2D, 3D, 4D, 5D padding with non-constant padding are supported for now"
  _32 = uninitialized(Tensor)
  _33 = torch.eq(torch.remainder(torch.len(pad), 2), 0)
  if _33:
    pass
  else:
    ops.prim.RaiseException(_27)
  _34 = torch.le(torch.floordiv(torch.len(pad), 2), torch.dim(input))
  if _34:
    pass
  else:
    ops.prim.RaiseException(_28)
  if torch.eq(mode, "constant"):
    _36 = torch.constant_pad_nd(input, pad, value)
    _35 = _36
  else:
    if torch.eq(value, 0.):
      pass
    else:
      _37 = torch.add("AssertionError: ", torch.format(_29, mode))
      ops.prim.RaiseException(_37)
    if torch.eq(torch.len(pad), 2):
      if torch.eq(torch.dim(input), 2):
        _39 = True
      else:
        _39 = torch.eq(torch.dim(input), 3)
      _38 = _39
    else:
      _38 = False
    if _38:
      if torch.eq(mode, "reflect"):
        _42 = torch.reflection_pad1d(input, pad)
        _41 = _42
      else:
        if torch.eq(mode, "replicate"):
          _44 = torch.replication_pad1d(input, pad)
          _43 = _44
        else:
          if torch.eq(mode, "circular"):
            _45 = _30(input, pad, )
          else:
            ops.prim.RaiseException("")
            _45 = _32
          _43 = _45
        _41 = _43
      _40 = _41
    else:
      if torch.eq(torch.len(pad), 4):
        if torch.eq(torch.dim(input), 3):
          _47 = True
        else:
          _47 = torch.eq(torch.dim(input), 4)
        _46 = _47
      else:
        _46 = False
      if _46:
        if torch.eq(mode, "reflect"):
          _50 = torch.reflection_pad2d(input, pad)
          _49 = _50
        else:
          if torch.eq(mode, "replicate"):
            _52 = torch.replication_pad2d(input, pad)
            _51 = _52
          else:
            if torch.eq(mode, "circular"):
              _53 = _30(input, pad, )
            else:
              ops.prim.RaiseException("")
              _53 = _32
            _51 = _53
          _49 = _51
        _48 = _49
      else:
        if torch.eq(torch.len(pad), 6):
          if torch.eq(torch.dim(input), 4):
            _55 = True
          else:
            _56 = torch.eq(torch.dim(input), 5)
            _55 = _56
          _54 = _55
        else:
          _54 = False
        if _54:
          if torch.eq(mode, "reflect"):
            _59 = torch.reflection_pad3d(input, pad)
            _58 = _59
          else:
            if torch.eq(mode, "replicate"):
              _61 = torch.replication_pad3d(input, pad)
              _60 = _61
            else:
              _62 = torch.eq(mode, "circular")
              if _62:
                _63 = _30(input, pad, )
              else:
                ops.prim.RaiseException("")
                _63 = _32
              _60 = _63
            _58 = _60
          _57 = _58
        else:
          ops.prim.RaiseException(_31)
          _57 = _32
        _48 = _57
      _40 = _48
    _35 = _40
  return _35
def _pad_circular(input: Tensor,
    padding: List[int]) -> Tensor:
  _64 = "AssertionError: Padding value causes wrapping around more than once."
  _65 = "AssertionError: Negative padding value is resulting in an empty dimension."
  in_shape = torch.size(input)
  paddable_shape = torch.slice(in_shape, 2)
  ndim = torch.len(paddable_shape)
  _66 = [9223372036854775807, torch.len(paddable_shape)]
  for idx in range(ops.prim.min(_66)):
    size = paddable_shape[idx]
    _67 = torch.neg(torch.add(torch.mul(idx, 2), 1))
    if torch.le(padding[_67], size):
      pass
    else:
      ops.prim.RaiseException(_64)
    _68 = torch.neg(torch.add(torch.mul(idx, 2), 2))
    if torch.le(padding[_68], size):
      pass
    else:
      ops.prim.RaiseException(_64)
    _69 = torch.neg(torch.add(torch.mul(idx, 2), 1))
    _70 = padding[_69]
    _71 = torch.neg(torch.add(torch.mul(idx, 2), 2))
    _72 = torch.add(torch.add(_70, padding[_71]), size)
    if torch.ge(_72, 0):
      pass
    else:
      ops.prim.RaiseException(_65)
  out_shape = torch.slice(in_shape, None, 2)
  _73 = [9223372036854775807, torch.len(paddable_shape)]
  out_shape0 = out_shape
  for idx0 in range(ops.prim.min(_73)):
    size0 = paddable_shape[idx0]
    _74 = torch.neg(torch.add(torch.mul(idx0, 2), 1))
    _75 = torch.add(size0, padding[_74])
    _76 = torch.neg(torch.add(torch.mul(idx0, 2), 2))
    out_shape1 = torch.add_(out_shape0, [torch.add(_75, padding[_76])])
    out_shape0 = out_shape1
  out = torch.new_empty(input, out_shape0)
  if torch.eq(ndim, 1):
    out_d0 = ops.prim.max(padding[-2], 0)
    out_d1 = torch.sub(out_shape0[2], ops.prim.max(padding[-1], 0))
    in_d0 = ops.prim.max(torch.neg(padding[-2]), 0)
    _77 = in_shape[2]
    _78 = ops.prim.max(torch.neg(padding[-1]), 0)
    in_d1 = torch.sub(_77, _78)
    _79 = torch.slice(input, -1, in_d0, in_d1)
    _80 = torch.slice(out, -1, out_d0, out_d1)
    _81 = torch.copy_(_80, _79)
  else:
    if torch.eq(ndim, 2):
      out_d00 = ops.prim.max(padding[-2], 0)
      out_d10 = torch.sub(out_shape0[2], ops.prim.max(padding[-1], 0))
      out_h0 = ops.prim.max(padding[-4], 0)
      out_h1 = torch.sub(out_shape0[3], ops.prim.max(padding[-3], 0))
      in_d00 = ops.prim.max(torch.neg(padding[-2]), 0)
      _82 = in_shape[2]
      _83 = ops.prim.max(torch.neg(padding[-1]), 0)
      in_d10 = torch.sub(_82, _83)
      in_h0 = ops.prim.max(torch.neg(padding[-4]), 0)
      _84 = in_shape[3]
      _85 = ops.prim.max(torch.neg(padding[-3]), 0)
      in_h1 = torch.sub(_84, _85)
      _86 = torch.slice(input, -2, in_d00, in_d10)
      _87 = torch.slice(_86, -1, in_h0, in_h1)
      _88 = torch.slice(out, -2, out_d00, out_d10)
      _89 = torch.slice(_88, -1, out_h0, out_h1)
      _90 = torch.copy_(_89, _87)
    else:
      if torch.eq(ndim, 3):
        out_d01 = ops.prim.max(padding[-2], 0)
        out_d11 = torch.sub(out_shape0[2], ops.prim.max(padding[-1], 0))
        out_h00 = ops.prim.max(padding[-4], 0)
        out_h10 = torch.sub(out_shape0[3], ops.prim.max(padding[-3], 0))
        out_w0 = ops.prim.max(padding[-6], 0)
        out_w1 = torch.sub(out_shape0[4], ops.prim.max(padding[-5], 0))
        in_d01 = ops.prim.max(torch.neg(padding[-2]), 0)
        _91 = in_shape[2]
        _92 = ops.prim.max(torch.neg(padding[-1]), 0)
        in_d11 = torch.sub(_91, _92)
        in_h00 = ops.prim.max(torch.neg(padding[-4]), 0)
        _93 = in_shape[3]
        _94 = ops.prim.max(torch.neg(padding[-3]), 0)
        in_h10 = torch.sub(_93, _94)
        in_w0 = ops.prim.max(torch.neg(padding[-6]), 0)
        _95 = in_shape[4]
        _96 = ops.prim.max(torch.neg(padding[-5]), 0)
        in_w1 = torch.sub(_95, _96)
        _97 = torch.slice(input, -3, in_d01, in_d11)
        _98 = torch.slice(_97, -2, in_h00, in_h10)
        _99 = torch.slice(_98, -1, in_w0, in_w1)
        _100 = torch.slice(out, -3, out_d01, out_d11)
        _101 = torch.slice(_100, -2, out_h00, out_h10)
        _102 = torch.slice(_101, -1, out_w0, out_w1)
        _103 = torch.copy_(_102, _99)
      else:
        pass
  if torch.gt(padding[-2], 0):
    _104 = torch.sub(out_shape0[2], padding[-2])
    i0 = torch.sub(_104, ops.prim.max(padding[-1], 0))
    i1 = torch.sub(out_shape0[2], ops.prim.max(padding[-1], 0))
    o1 = padding[-2]
    _105 = torch.slice(torch.slice(torch.slice(out), 1), 2, i0, i1)
    _106 = torch.slice(torch.slice(torch.slice(out), 1), 2, 0, o1)
    _107 = torch.copy_(_106, _105)
  else:
    pass
  if torch.gt(padding[-1], 0):
    i00 = ops.prim.max(padding[-2], 0)
    i10 = torch.add(ops.prim.max(padding[-2], 0), padding[-1])
    o0 = torch.sub(out_shape0[2], padding[-1])
    o10 = out_shape0[2]
    _108 = torch.slice(torch.slice(torch.slice(out), 1), 2, i00, i10)
    _109 = torch.slice(torch.slice(torch.slice(out), 1), 2, o0, o10)
    _110 = torch.copy_(_109, _108)
  else:
    pass
  if torch.gt(torch.len(padding), 2):
    if torch.gt(padding[-4], 0):
      _111 = torch.sub(out_shape0[3], padding[-4])
      i01 = torch.sub(_111, ops.prim.max(padding[-3], 0))
      i11 = torch.sub(out_shape0[3], ops.prim.max(padding[-3], 0))
      o11 = padding[-4]
      _112 = torch.slice(torch.slice(torch.slice(out), 1), 2)
      _113 = torch.slice(_112, 3, i01, i11)
      _114 = torch.slice(torch.slice(torch.slice(out), 1), 2)
      _115 = torch.copy_(torch.slice(_114, 3, 0, o11), _113)
    else:
      pass
    if torch.gt(padding[-3], 0):
      i02 = ops.prim.max(padding[-4], 0)
      i12 = torch.add(ops.prim.max(padding[-4], 0), padding[-3])
      o00 = torch.sub(out_shape0[3], padding[-3])
      o12 = out_shape0[3]
      _116 = torch.slice(torch.slice(torch.slice(out), 1), 2)
      _117 = torch.slice(_116, 3, i02, i12)
      _118 = torch.slice(torch.slice(torch.slice(out), 1), 2)
      _119 = torch.copy_(torch.slice(_118, 3, o00, o12), _117)
    else:
      pass
  else:
    pass
  if torch.gt(torch.len(padding), 4):
    if torch.gt(padding[-6], 0):
      _120 = torch.sub(out_shape0[4], padding[-6])
      i03 = torch.sub(_120, ops.prim.max(padding[-5], 0))
      i13 = torch.sub(out_shape0[4], ops.prim.max(padding[-5], 0))
      o13 = padding[-6]
      _121 = torch.slice(torch.slice(torch.slice(out), 1), 2)
      _122 = torch.slice(torch.slice(_121, 3), 4, i03, i13)
      _123 = torch.slice(torch.slice(torch.slice(out), 1), 2)
      _124 = torch.slice(torch.slice(_123, 3), 4, 0, o13)
      _125 = torch.copy_(_124, _122)
    else:
      pass
    if torch.gt(padding[-5], 0):
      i04 = ops.prim.max(padding[-6], 0)
      i14 = torch.add(ops.prim.max(padding[-6], 0), padding[-5])
      o01 = torch.sub(out_shape0[4], padding[-5])
      o14 = out_shape0[4]
      _126 = torch.slice(torch.slice(torch.slice(out), 1), 2)
      _127 = torch.slice(torch.slice(_126, 3), 4, i04, i14)
      _128 = torch.slice(torch.slice(torch.slice(out), 1), 2)
      _129 = torch.slice(torch.slice(_128, 3), 4, o01, o14)
      _130 = torch.copy_(_129, _127)
    else:
      pass
  else:
    pass
  return out
