class BatchNorm1d(Module):
  __parameters__ = ["weight", "bias", ]
  __buffers__ = ["running_mean", "running_var", "num_batches_tracked", ]
  weight : Tensor
  bias : Tensor
  running_mean : Tensor
  running_var : Tensor
  num_batches_tracked : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  eps : Final[float] = 1.0000000000000001e-05
  track_running_stats : Final[bool] = True
  affine : Final[bool] = True
  num_features : Final[int] = 4
  momentum : Final[float] = 0.10000000000000001
  def forward(self: __torch__.torch.nn.modules.batchnorm.BatchNorm1d,
    input: Tensor) -> Tensor:
    _0 = __torch__.torch.nn.functional.batch_norm
    _1 = (self)._check_input_dim(input, )
    training = self.training
    if training:
      num_batches_tracked = self.num_batches_tracked
      _2 = torch.add_(num_batches_tracked, 1)
    else:
      pass
    training0 = self.training
    if training0:
      bn_training = True
    else:
      bn_training = False
    running_mean = self.running_mean
    running_var = self.running_var
    weight = self.weight
    bias = self.bias
    _3 = _0(input, running_mean, running_var, weight, bias, bn_training, 0.10000000000000001, 1.0000000000000001e-05, )
    return _3
  def _check_input_dim(self: __torch__.torch.nn.modules.batchnorm.BatchNorm1d,
    input: Tensor) -> NoneType:
    _4 = "expected 2D or 3D input (got {}D input)"
    if torch.ne(torch.dim(input), 2):
      _5 = torch.ne(torch.dim(input), 3)
    else:
      _5 = False
    if _5:
      _6 = torch.format(_4, torch.dim(input))
      ops.prim.RaiseException(_6)
    else:
      pass
    return None
class BatchNorm2d(Module):
  __parameters__ = ["weight", "bias", ]
  __buffers__ = ["running_mean", "running_var", "num_batches_tracked", ]
  weight : Tensor
  bias : Tensor
  running_mean : Tensor
  running_var : Tensor
  num_batches_tracked : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  eps : Final[float] = 1.0000000000000001e-05
  track_running_stats : Final[bool] = True
  affine : Final[bool] = True
  num_features : Final[int] = 4
  momentum : Final[float] = 0.10000000000000001
  def forward(self: __torch__.torch.nn.modules.batchnorm.BatchNorm2d,
    input: Tensor) -> Tensor:
    _7 = __torch__.torch.nn.functional.batch_norm
    _8 = (self)._check_input_dim(input, )
    training = self.training
    if training:
      num_batches_tracked = self.num_batches_tracked
      _9 = torch.add_(num_batches_tracked, 1)
    else:
      pass
    training1 = self.training
    if training1:
      bn_training = True
    else:
      bn_training = False
    running_mean = self.running_mean
    running_var = self.running_var
    weight = self.weight
    bias = self.bias
    _10 = _7(input, running_mean, running_var, weight, bias, bn_training, 0.10000000000000001, 1.0000000000000001e-05, )
    return _10
  def _check_input_dim(self: __torch__.torch.nn.modules.batchnorm.BatchNorm2d,
    input: Tensor) -> NoneType:
    if torch.ne(torch.dim(input), 4):
      _11 = torch.format("expected 4D input (got {}D input)", torch.dim(input))
      ops.prim.RaiseException(_11)
    else:
      pass
    return None
class BatchNorm3d(Module):
  __parameters__ = ["weight", "bias", ]
  __buffers__ = ["running_mean", "running_var", "num_batches_tracked", ]
  weight : Tensor
  bias : Tensor
  running_mean : Tensor
  running_var : Tensor
  num_batches_tracked : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  eps : Final[float] = 1.0000000000000001e-05
  track_running_stats : Final[bool] = True
  affine : Final[bool] = True
  num_features : Final[int] = 4
  momentum : Final[float] = 0.10000000000000001
  def forward(self: __torch__.torch.nn.modules.batchnorm.BatchNorm3d,
    input: Tensor) -> Tensor:
    _12 = __torch__.torch.nn.functional.batch_norm
    _13 = (self)._check_input_dim(input, )
    training = self.training
    if training:
      num_batches_tracked = self.num_batches_tracked
      _14 = torch.add_(num_batches_tracked, 1)
    else:
      pass
    training2 = self.training
    if training2:
      bn_training = True
    else:
      bn_training = False
    running_mean = self.running_mean
    running_var = self.running_var
    weight = self.weight
    bias = self.bias
    _15 = _12(input, running_mean, running_var, weight, bias, bn_training, 0.10000000000000001, 1.0000000000000001e-05, )
    return _15
  def _check_input_dim(self: __torch__.torch.nn.modules.batchnorm.BatchNorm3d,
    input: Tensor) -> NoneType:
    if torch.ne(torch.dim(input), 5):
      _16 = torch.format("expected 5D input (got {}D input)", torch.dim(input))
      ops.prim.RaiseException(_16)
    else:
      pass
    return None
