class InstanceNorm1d(Module):
  __parameters__ = ["weight", "bias", ]
  __buffers__ = ["running_mean", "running_var", "num_batches_tracked", ]
  weight : NoneType
  bias : NoneType
  running_mean : NoneType
  running_var : NoneType
  num_batches_tracked : NoneType
  training : bool
  _is_full_backward_hook : NoneType
  eps : Final[float] = 1.0000000000000001e-05
  track_running_stats : Final[bool] = False
  affine : Final[bool] = False
  num_features : Final[int] = 4
  momentum : Final[float] = 0.10000000000000001
  def forward(self: __torch__.torch.nn.modules.instancenorm.InstanceNorm1d,
    input: Tensor) -> Tensor:
    _0 = (self)._check_input_dim(input, )
    _1 = torch.eq(torch.dim(input), (self)._get_no_batch_dim())
    if _1:
      _3 = (self)._handle_no_batch_input(input, )
      _2 = _3
    else:
      _4 = (self)._apply_instance_norm(input, )
      _2 = _4
    return _2
  def _check_input_dim(self: __torch__.torch.nn.modules.instancenorm.InstanceNorm1d,
    input: Tensor) -> NoneType:
    _5 = "expected 2D or 3D input (got {}D input)"
    _6 = torch.dim(input)
    _7 = torch.__not__(torch.__contains__([2, 3], _6))
    if _7:
      _8 = torch.format(_5, torch.dim(input))
      ops.prim.RaiseException(_8)
    else:
      pass
    return None
  def _get_no_batch_dim(self: __torch__.torch.nn.modules.instancenorm.InstanceNorm1d) -> int:
    return 2
  def _handle_no_batch_input(self: __torch__.torch.nn.modules.instancenorm.InstanceNorm1d,
    input: Tensor) -> Tensor:
    _9 = (self)._apply_instance_norm(torch.unsqueeze(input, 0), )
    return torch.squeeze(_9, 0)
  def _apply_instance_norm(self: __torch__.torch.nn.modules.instancenorm.InstanceNorm1d,
    input: Tensor) -> Tensor:
    _10 = __torch__.torch.nn.functional.instance_norm
    running_mean = self.running_mean
    running_var = self.running_var
    weight = self.weight
    bias = self.bias
    _11 = _10(input, running_mean, running_var, weight, bias, True, 0.10000000000000001, 1.0000000000000001e-05, )
    return _11
class InstanceNorm2d(Module):
  __parameters__ = ["weight", "bias", ]
  __buffers__ = ["running_mean", "running_var", "num_batches_tracked", ]
  weight : NoneType
  bias : NoneType
  running_mean : NoneType
  running_var : NoneType
  num_batches_tracked : NoneType
  training : bool
  _is_full_backward_hook : NoneType
  eps : Final[float] = 1.0000000000000001e-05
  track_running_stats : Final[bool] = False
  affine : Final[bool] = False
  num_features : Final[int] = 4
  momentum : Final[float] = 0.10000000000000001
  def forward(self: __torch__.torch.nn.modules.instancenorm.InstanceNorm2d,
    input: Tensor) -> Tensor:
    _12 = (self)._check_input_dim(input, )
    _13 = torch.eq(torch.dim(input), (self)._get_no_batch_dim())
    if _13:
      _15 = (self)._handle_no_batch_input(input, )
      _14 = _15
    else:
      _16 = (self)._apply_instance_norm(input, )
      _14 = _16
    return _14
  def _check_input_dim(self: __torch__.torch.nn.modules.instancenorm.InstanceNorm2d,
    input: Tensor) -> NoneType:
    _17 = "expected 3D or 4D input (got {}D input)"
    _18 = torch.dim(input)
    _19 = torch.__not__(torch.__contains__([3, 4], _18))
    if _19:
      _20 = torch.format(_17, torch.dim(input))
      ops.prim.RaiseException(_20)
    else:
      pass
    return None
  def _get_no_batch_dim(self: __torch__.torch.nn.modules.instancenorm.InstanceNorm2d) -> int:
    return 3
  def _handle_no_batch_input(self: __torch__.torch.nn.modules.instancenorm.InstanceNorm2d,
    input: Tensor) -> Tensor:
    _21 = (self)._apply_instance_norm(torch.unsqueeze(input, 0), )
    return torch.squeeze(_21, 0)
  def _apply_instance_norm(self: __torch__.torch.nn.modules.instancenorm.InstanceNorm2d,
    input: Tensor) -> Tensor:
    _22 = __torch__.torch.nn.functional.instance_norm
    running_mean = self.running_mean
    running_var = self.running_var
    weight = self.weight
    bias = self.bias
    _23 = _22(input, running_mean, running_var, weight, bias, True, 0.10000000000000001, 1.0000000000000001e-05, )
    return _23
class InstanceNorm3d(Module):
  __parameters__ = ["weight", "bias", ]
  __buffers__ = ["running_mean", "running_var", "num_batches_tracked", ]
  weight : NoneType
  bias : NoneType
  running_mean : NoneType
  running_var : NoneType
  num_batches_tracked : NoneType
  training : bool
  _is_full_backward_hook : NoneType
  eps : Final[float] = 1.0000000000000001e-05
  track_running_stats : Final[bool] = False
  affine : Final[bool] = False
  num_features : Final[int] = 4
  momentum : Final[float] = 0.10000000000000001
  def forward(self: __torch__.torch.nn.modules.instancenorm.InstanceNorm3d,
    input: Tensor) -> Tensor:
    _24 = (self)._check_input_dim(input, )
    _25 = torch.eq(torch.dim(input), (self)._get_no_batch_dim())
    if _25:
      _27 = (self)._handle_no_batch_input(input, )
      _26 = _27
    else:
      _28 = (self)._apply_instance_norm(input, )
      _26 = _28
    return _26
  def _check_input_dim(self: __torch__.torch.nn.modules.instancenorm.InstanceNorm3d,
    input: Tensor) -> NoneType:
    _29 = "expected 4D or 5D input (got {}D input)"
    _30 = torch.dim(input)
    _31 = torch.__not__(torch.__contains__([4, 5], _30))
    if _31:
      _32 = torch.format(_29, torch.dim(input))
      ops.prim.RaiseException(_32)
    else:
      pass
    return None
  def _get_no_batch_dim(self: __torch__.torch.nn.modules.instancenorm.InstanceNorm3d) -> int:
    return 4
  def _handle_no_batch_input(self: __torch__.torch.nn.modules.instancenorm.InstanceNorm3d,
    input: Tensor) -> Tensor:
    _33 = (self)._apply_instance_norm(torch.unsqueeze(input, 0), )
    return torch.squeeze(_33, 0)
  def _apply_instance_norm(self: __torch__.torch.nn.modules.instancenorm.InstanceNorm3d,
    input: Tensor) -> Tensor:
    _34 = __torch__.torch.nn.functional.instance_norm
    running_mean = self.running_mean
    running_var = self.running_var
    weight = self.weight
    bias = self.bias
    _35 = _34(input, running_mean, running_var, weight, bias, True, 0.10000000000000001, 1.0000000000000001e-05, )
    return _35
